; ---------------------+---------+---------------------------
; mfhe rebuild version | hsp2.60 | Programmed by rophon 2003
; ---------------------+---------+---------------------------

	#include "llmod.as"
	#include "dragdrop.as"
	#include "obj.as"
	#include "winact.as"

; -------------
; inifile load
; -------------
	nowdir=exedir
	dim wpos,3
	exist nowdir+"\\mfhe2.ini"
	if strsize=-1 {
		wpos.0=0 : wpos.1=0 : wpos.2=0 : msf=0
		} else {
		bload nowdir+"\\mfhe2.ini",wpos : msf=wpos.2
		}

; ------------+----------------------------------------
;  initialize | paramater / gui window / dragdrop etc.
; ------------+----------------------------------------
	sdim culm0,66 : sdim culm1,66 : sdim culm2,66
	sdim culm3,66 : sdim culm4,66 : sdim culm5,66
	sdim bk0,66 : sdim bk1,66 : sdim bk2,66
	sdim bk3,66 : sdim bk4,66 : sdim bk5,66
	sdim path,512 : sdim ddin,512
	sdim msg,10240 : z="" : a=0 : b=0 : nomagic=0

	title "MFHE - Edition II"
	msg="/// Multi Format Header Editor - second edition ///"
	screen 0,420,240,0,wpos.0,wpos.1 : cls 1
	objmode 1,1 : sysfont 17 : objsize 80,20

	pos 060,010 : input culm0,250,20,64	;0
	pos 060,030 : input culm1,250,20,64	;1
	pos 060,050 : input culm2,250,20,64	;2
	pos 060,070 : input culm3,250,20,64	;3
	pos 060,090 : input culm4,250,20,64	;4
	pos 060,110 : input culm5,250,20,64	;5
	pos 000,160 : mesbox msg,420,80,0	;6

	pos 005,015 : mes "   music"
	pos 005,035 : mes "    game"
	pos 005,055 : mes "   maker"
	pos 005,075 : mes "     emu"
	pos 005,095 : mes "    ripper"
	pos 005,115 : mes "comment"

	pos 330,010 : button "load",*btn	;7
	pos 330,030 : button "save",*btn	;8
	pos 330,070 : button "infoback",*btn	;9
	pos 330,110 : button "end",*btn		;10
	pos 330,050 : button "clear",*btn	;11

	pos 330,135 : chkbox "No popup",msf	;12

	objgray 9,0 : objgray 11,0
	repeat 6 : objgray cnt,0 : loop : objsel 6
	gsel 0,1
	dd_accept ddin,a,0 : dd_reject 0,1
	goto *main
; ------+----------------------
*btn	; button press routine
; ------+----------------------
	objsel -1 : a=stat
	if a=7 : goto *f_load
	if a=8 : goto *f_save
	if a=9 : gosub *inf_ret
	if a=10 : goto *quit
	if a=11 {
		culm0="" : culm1="" : culm2="" : culm3="" : culm4="" : culm5=""
		repeat 6 : objprm cnt,"" : loop
		msg="clear header information.\n"+msg : gosub *msgchk
		}

; ------+----------------
*main	; main routine
; ------+----------------
	stick a,0,1 : if (a&128) : goto *quit
	getkey a,17 : if a=0 : c=0
	getkey b,83 : if (a=1)&(b=1)&(c=0) : c=1 : goto *f_save
	getkey b,66 : if (a=1)&(b=1)&(c=0) : c=1 : gosub *inf_ret
	if ddin!="" : goto *dropin
	await 10,5
	goto *main

; ------+------------------
*msgchk	; msg 10 line keep
; ------+------------------
	notesel msg : notemax a
	if a>10 {
		notedel 10 : goto *msgchk
		}
	objprm 6,msg
	return

; ------+------------------------
*dropin	; Drag&Drop filepath get
; ------+------------------------
	strlen a,ddin : a=a-2 : strmid path,ddin,0,a
	kak="" : strmid kak,path,-1,3 : charupper kak
	ddin=""
	if (kak!="NSF")&(kak!="GYM")&(kak!="S98")&(kak!="SPU") {
		if msf=0 : winact 0 : dialog "No support file.",1,"Drop Error"
		msg="Drop error : Not support format file.\n"+msg : gosub *msgchk
		goto *main
		}
	goto *load2

; ------+---------------------------
*f_load	; load button press routine
; ------+---------------------------
	dialog "GYM;*.NSF;*.S98;*.SPU",16,"Sound Log File"
	if stat=0 : goto *main
	path=refstr

; file include
; -------------
*load2
	nomagic=0
	exist path : size=strsize
	sdim orgfile,size : bload path,orgfile

; format check
; -------------
	fmt="" : strmid fmt,orgfile,0,3
	kak="" : strmid kak,path,-1,3 : charupper kak
	fnam="": getpath fnam,path,8

	if (fmt!="NES")&(fmt!="S98")&(fmt!="GYM")&(fmt!="SPU") {
		nomagic=1
		if (kak!="GYM")&(kak!="SPU") {
			msg="Not Support "+fnam+".\n"+msg : gosub *msgchk
			if msf=0 : winact : dialog "Out of support file.",1,"Error" : goto *main
			}
		}
	msg="load "+fnam+" information.\n"+msg : gosub *msgchk

; no magic format check
; ----------------------
	if nomagic=1 {
		if kak="GYM" {
			if msf=0 : winact : dialog "No Header GYM format.\nCreate Header information area.",1,"Information"
			bsave path+".bak",orgfile,size
			size+=427 : sdim gymhead,size
			repeat 427 : poke gymhead,cnt,$00 : loop
			poke gymhead,0,"G" : poke gymhead,1,"Y"
			poke gymhead,2,"M" : poke gymhead,3,"X"
			repeat size-427 : peek a,orgfile,cnt : poke gymhead,cnt+427,a : loop
			bsave path,gymhead,size
			sdim orgfile,size : bload path,orgfile
			fmt="GYM" : msg="Create header and backup file.\n"+msg : gosub *msgchk
			}
		if kak="SPU" {
			peek a,orgfile,0 : peek b,orgfile,1
			if (a=31)&(b=139) {
				msg="GZip compressed SPU. cannot edit this file.\n"+msg : gosub *msgchk
				if msf=0 : winact : dialog "GZ-compress SPU file!\nCan't edit informations.",1,"Not support"
				goto *main
				}
			poke orgfile,0,"S" : poke orgfile,1,"P"
			poke orgfile,2,"U" : poke orgfile,3,"1"
			fmt="SPU"
			}
		}

; header information load
; ------------------------
	bk0=culm0 : bk1=culm1 : bk2=culm2 : bk3=culm3 : bk4=culm4 : bk5=culm5
	repeat 6 : objprm cnt,"" : objgray cnt,0 : loop
	culm0="" : culm1="" : culm2="" : culm3="" : culm4="" : culm5=""
	objgray 11,1 : objgray 9,1

	if fmt="NES" {
		bload path,culm0,32,14
		bload path,culm4,32,46
		bload path,culm2,32,78
		clrobj 0,0 : clrobj 2,2 : clrobj 4,4
		pos 060,010 : input culm0,250,20,32
		pos 060,050 : input culm2,250,20,32
		pos 060,090 : input culm4,250,20,32
		objgray 0,1 : objgray 2,1 : objgray 4,1
		}

	if fmt="SPU" {
		bload path,culm0,64,68
		bload path,culm1,64,4
		bload path,culm2,32,132
		clrobj 0,2
		pos 060,010 : input culm0,250,20,64
		pos 060,030 : input culm1,250,20,64
		pos 060,050 : input culm2,250,20,32
		repeat 3 : objgray cnt,1 :loop
		}

	if fmt="GYM" {
		bload path,culm0,32,4
		bload path,culm1,32,36
		bload path,culm2,32,68
		bload path,culm3,32,100
		bload path,culm4,32,132
		bload path,culm5,32,164
		clrobj 0,5
		pos 060,010 : input culm0,250,20,32
		pos 060,030 : input culm1,250,20,32
		pos 060,050 : input culm2,250,20,32
		pos 060,070 : input culm3,250,20,32
		pos 060,090 : input culm4,250,20,32
		pos 060,110 : input culm5,250,20,32
		repeat 6 : objgray cnt,1 : loop
		}

	if fmt="S98" {
		peek s98,orgfile,16
		bload path,culm5,128,s98
		clrobj 5,5
		pos 060,110 : input culm5,250,20,64
		objgray 5,1
		}
	callback=1 : winact : goto *main

; ------+--------------------------
*f_save	; header information write
; ------+--------------------------

	if fmt="NES" {
		repeat 96 : poke orgfile,cnt+14,$00 : loop
		strlen a,culm0 : repeat a : strmid z,culm0,cnt,1 : poke orgfile,cnt+14,z : loop
		strlen a,culm2 : repeat a : strmid z,culm2,cnt,1 : poke orgfile,cnt+78,z : loop
		strlen a,culm4 : repeat a : strmid z,culm4,cnt,1 : poke orgfile,cnt+46,z : loop
		}

	if fmt="SPU" {
		repeat 160 : poke orgfile,cnt+4,$00 : loop
		strlen a,culm0 : repeat a : strmid z,culm0,cnt,1 : poke orgfile,cnt+68,z : loop
		strlen a,culm1 : repeat a : strmid z,culm1,cnt,1 : poke orgfile,cnt+4,z : loop
		strlen a,culm2 : repeat a : strmid z,culm2,cnt,1 : poke orgfile,cnt+132,z : loop
		}

	if fmt="GYM" {
		repeat 196 : poke orgfile,cnt+4,$00 : loop
		strlen a,culm0 : repeat a : strmid z,culm0,cnt,1 : poke orgfile,cnt+4,z : loop
		strlen a,culm1 : repeat a : strmid z,culm1,cnt,1 : poke orgfile,cnt+36,z : loop
		strlen a,culm2 : repeat a : strmid z,culm2,cnt,1 : poke orgfile,cnt+68,z : loop
		strlen a,culm3 : repeat a : strmid z,culm3,cnt,1 : poke orgfile,cnt+100,z : loop
		strlen a,culm4 : repeat a : strmid z,culm4,cnt,1 : poke orgfile,cnt+132,z : loop
		strlen a,culm5 : repeat a : strmid z,culm5,cnt,1 : poke orgfile,cnt+164,z : loop
		}

	if fmt="S98" {
		poke orgfile,16,$40
		repeat 64 : poke orgfile,cnt+$40,$00 : loop
		strlen a,culm5 : repeat a : strmid z,culm5,cnt,1 : poke orgfile,cnt+$40,z : loop
		}

	bsave path,orgfile,size
	msg="Overwrite "+fnam+" information.\n"+msg : gosub *msgchk
	goto *main

; --------------+----------------------
*inf_ret	; callback information
; --------------+----------------------
	if callback=0 : return
	callback=1
	culm0=bk0 : culm1=bk1 : culm2=bk2 : culm3=bk3 : culm4=bk4 : culm5=bk5
	if fmt="NES" {
		objprm 0,culm0 : objprm 2,culm2 : objprm 4,culm4
		}
	if fmt="SPU" {
		objprm 0,culm0 : objprm 1,culm1 : objprm 2,culm2
		}
	if fmt="GYM" {
		objprm 0,culm0 : objprm 1,culm1 : objprm 2,culm2
		objprm 3,culm3 : objprm 4,culm4 : objprm 5,culm5
		}
	if fmt="S98" : objprm 5,culm5
	msg="Callback before information.\n"+msg : gosub *msgchk
	return

; ------+----------------
*quit	; escape program
; ------+----------------
	ginfo 2
	wpos.0=prmx : wpos.1=prmy : wpos.2=msf
	bsave nowdir+"\\mfhe2.ini",wpos
	end
